local frame = CreateFrame("FRAME"); -- Need a frame to respond to events
frame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
frame:RegisterEvent("PLAYER_MONEY"); -- Fired when user receive ou spend money
frame:RegisterEvent("GUILDBANKFRAME_OPENED"); -- Fired when user open guild bank

function frame:OnEvent(event, arg1)
  if event == "ADDON_LOADED" and arg1 == "GuildDonation" then
    -- Our saved variables are ready at this point. If there are none, all variables will set to nil.
    if TotalDevido == nil then
      TotalDevido = 0; -- This is the first time this addon is loaded; initialize the count to 0.
    end
    if TotalDeGold == nil then
      TotalDeGold = GetMoney(); -- This is the first time this addon is loaded; initialize the count to user current money.
    end
    if Porcentagem == nil then
      Porcentagem = 5; -- This is the first time this addon is loaded; initialize the count to 5%.
    end
  elseif event == "PLAYER_MONEY" then
    -- User received or spended money
    local money = GetMoney()
    -- User received money
    if money > TotalDeGold then
      local divida = money - TotalDeGold;
      divida = math.floor(math.floor(divida/100)*Porcentagem);
      TotalDevido = TotalDevido + divida;
    end
    TotalDeGold = money;
  elseif event == "GUILDBANKFRAME_OPENED" then
    -- User opened guild bank
    DepositGuildBankMoney(TotalDevido)
    local money = TotalDevido
    local gold = floor(abs(money / 10000))
    local silver = floor(abs(mod(money / 100, 100)))
    local copper = floor(abs(mod(money, 100)))
    print(format("|cfff48cba <GuildDonation> |r Your donation of %d gold %d silver %d copper has been done.", gold, silver, copper))
    TotalDevido = 0
  end
end

function isint(n)
  if tonumber(n) ~= nil then
     return tonumber(n)==math.floor(tonumber(n))
  end
end

frame:SetScript("OnEvent", frame.OnEvent);
SLASH_GUILDDONATION1 = "/gd";
function SlashCmdList.GUILDDONATION(msg)

  if msg == "" then
    local money = TotalDevido
    local gold = floor(abs(money / 10000))
    local silver = floor(abs(mod(money / 100, 100)))
    local copper = floor(abs(mod(money, 100)))
    print(format("|cfff48cba <GuildDonation> |r Your current donation is %d gold %d silver %d copper to the guild.", gold, silver, copper))
    print(format("|cfff48cba <GuildDonation> |r Your current donation percentage is %d%%.", Porcentagem))
  else 
    if isint(msg) then
      local number = math.floor(tonumber(msg))
      if number >= 1 or number <= 100 then
        Porcentagem = number
        print(format("|cfff48cba <GuildDonation> |r Your donation percentage is %d%% now.",Porcentagem))
      else
        print(format("|cfff48cba <GuildDonation> |r Invalid number.",Porcentagem))
      end
    else
      local money = TotalDevido
      local gold = floor(abs(money / 10000))
      local silver = floor(abs(mod(money / 100, 100)))
      local copper = floor(abs(mod(money, 100)))
      print(format("|cfff48cba <GuildDonation> |r Your current donation is %d gold %d silver %d copper to the guild.", gold, silver, copper))
      print(format("|cfff48cba <GuildDonation> |r Your current donation percentage is %d%%.", Porcentagem))
    end
  end
end


